//+------------------------------------------------------------------+
//|                                              Real Woodie CCI.mq4 |
//|                Based on the code of Jason Robinson (jnrtrading). |
//|                                                                  |
//| After read the Woodie introductory document I started a search   |
//| for the right coloured CCI.                                      |
//| I cant find anyone in accomplish with the explanation of Woodie |
//| So, I take the code from another CCI, and I added                |
//| the center LSMA line according to the official explanation.      |
//| Everything you see is an exact copy like its explained in the   |
//| document new_woodie_do1. Specially the colors.                   |
//| If you have some doubts can obtain a copy                        |
//| from http://woodiescciclub.com/                                  |
//|                                                                  |
//| Linuxser 2007                                                    |
//| for any doubts or suggestions contact me on Forex-TSD forum      |
//+------------------------------------------------------------------+
#property copyright "Under The GNU General Public License"
#property link      "www.gnu.org"

#property indicator_separate_window
#property indicator_buffers 8
#property indicator_color1 Blue
#property indicator_width1 2
#property indicator_color2 Red
#property indicator_width2 2
#property indicator_color3 Yellow //Gray
#property indicator_width3 2
#property indicator_color4 Yellow
#property indicator_width4 2
#property indicator_color5 DarkKhaki //Black
#property indicator_width5 2
#property indicator_color6 MintCream //Crimson
#property indicator_width6 2
#property indicator_color7 Lime
#property indicator_width7 2
#property indicator_color8 Red
#property indicator_width8 2



#property indicator_level1 100
#property indicator_level2 250
#property indicator_level3 350
#property indicator_level4 450
#property indicator_level5 -450
#property indicator_level6 -350
#property indicator_level7 -250
#property indicator_level8 -100
#property indicator_levelcolor Silver //SeaGreen
#property indicator_levelstyle STYLE_DOT //SOLID
#property indicator_levelwidth 1

//---- input parameters
extern int TrendCCI_Period = 55;//14
extern int EntryCCI_Period = 13;//6
extern int LSMAPeriod = 25;     // LSMA period


int FromZero   = 0;      // Distance from zero level
int EMAPeriod  = 55;//34     //  period   <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<< NB <<<<<<<<<



double TrendCCI[];
double EntryCCI[];
double CCITrendUp[];
double CCITrendDown[];
double CCINoTrend[];
double CCITimeBar[];
double LSMABuffer1[];
double LSMABuffer2[];
double ZeroLine[];
double LineHighEMA[];
double LineLowEMA[];

int trendUp, trendDown;



//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()  
   {
   string short_name;
//---- indicators
   SetIndexStyle(4, DRAW_LINE, STYLE_SOLID, 2);
   SetIndexBuffer(4, TrendCCI);
   SetIndexLabel(4, "TrendCCI");
   
   SetIndexStyle(0, DRAW_HISTOGRAM, 0);
   SetIndexBuffer(0, CCITrendUp);
   SetIndexLabel (0, NULL);
   
   SetIndexStyle(1, DRAW_HISTOGRAM, 0);
   SetIndexBuffer(1, CCITrendDown);
   SetIndexLabel (1, NULL);
    
   SetIndexStyle(2, DRAW_HISTOGRAM, 0);
   SetIndexBuffer(2, CCINoTrend);
   SetIndexLabel (2, NULL);
   
   SetIndexStyle(3, DRAW_HISTOGRAM, 0);
   SetIndexBuffer(3, CCITimeBar);
   SetIndexLabel (3, NULL);
   
   SetIndexStyle(5, DRAW_LINE, STYLE_SOLID, 2);// 1 <<<<<<<<<<<<<<<<<<<
   SetIndexBuffer(5, EntryCCI);
   SetIndexLabel(5, "EntryCCI");
      
   SetIndexStyle (6, DRAW_ARROW, 0);
   SetIndexBuffer(6, LSMABuffer2);
   SetIndexLabel (6, NULL);    
   SetIndexEmptyValue(6,EMPTY_VALUE);
   SetIndexArrow(6,167); 
    
   SetIndexStyle (7, DRAW_ARROW, 0);     
   SetIndexBuffer(7, LSMABuffer1);
   SetIndexLabel (7, NULL);
   SetIndexEmptyValue(7,EMPTY_VALUE);
   SetIndexArrow(7,167);
   
   short_name="Woodie CCI(" + TrendCCI_Period + "), TCCI: (" +EntryCCI_Period+ ")";  
   IndicatorShortName(short_name);
    
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//---- 
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start() {

   int limit, i, trendCCI, entryCCI;
   int counted_bars = IndicatorCounted();
   static datetime prevtime = 0;
//---- check for possible errors
   if(counted_bars < 0) return(-1);
//---- last counted bar will be recounted
   if(counted_bars > 0) counted_bars--;

   limit=Bars;//-counted_bars;   

   trendCCI = TrendCCI_Period;
   entryCCI = EntryCCI_Period;    
   
   for(i = limit; i >= 0; i--) {
      CCINoTrend[i] = 0;
      CCITrendDown[i] = 0;
      CCITimeBar[i] = 0;
      CCITrendUp[i] = 0;
      ZeroLine[i] = 0;
      TrendCCI[i] = iCCI(NULL, 0, trendCCI, PRICE_TYPICAL, i);
      EntryCCI[i] = iCCI(NULL, 0, entryCCI, PRICE_TYPICAL, i);
      
      if(TrendCCI[i] > 0 && TrendCCI[i+1] < 0) {
         if (trendDown > 4) trendUp = 0;
      }
      if (TrendCCI[i] > 0) {
         if (trendUp < 5){
            CCINoTrend[i] = TrendCCI[i];
            trendUp++;
         }
         if (trendUp == 5) {
            CCITimeBar[i] = TrendCCI[i];
            trendUp++;
         }
         if (trendUp > 5) {
            CCITrendUp[i] = TrendCCI[i];
         }
      }
      if(TrendCCI[i] < 0 && TrendCCI[i+1] > 0) {
         if (trendUp > 4) trendDown = 0;
      }
      if (TrendCCI[i] < 0) {
         
         if (trendDown < 5){
            CCINoTrend[i] = TrendCCI[i];
            trendDown++;
         }
         if (trendDown == 5) {
            CCITimeBar[i] = TrendCCI[i];
            trendDown++;
         }
         if (trendDown > 5) {
            CCITrendDown[i] = TrendCCI[i];
         }
      }
   }
   
//---- Color Middle Line LSMA
  
  double sum, lengthvar, tmp, wt;
  int shift;
  int Draw4HowLong, loopbegin;

  if (counted_bars<0) return;
  if (counted_bars>0) counted_bars--;
  counted_bars = Bars - counted_bars;
  for (shift=0; shift<counted_bars; shift++) {
    LineLowEMA[shift] = -FromZero;
    LineHighEMA[shift] = -FromZero;

    double EmaValue = iMA(NULL, 0, EMAPeriod, 0, MODE_EMA, PRICE_TYPICAL, shift);
    if (Close[shift]>EmaValue) LineHighEMA[shift] = EMPTY_VALUE;
    if (Close[shift]<EmaValue) LineLowEMA[shift] = EMPTY_VALUE;
  }

  Draw4HowLong = Bars-LSMAPeriod - 5;
  loopbegin = Draw4HowLong - LSMAPeriod - 1;

  for(shift=loopbegin; shift>=0; shift--) {
    sum = 0;
    for (i=LSMAPeriod; i>=1; i--) {
      lengthvar = LSMAPeriod + 1;
      lengthvar /= 3;
      tmp = 0;
      tmp = (i - lengthvar) * Close[LSMAPeriod-i+shift];
      sum+=tmp;
    }
    wt = sum * 6 / (LSMAPeriod * (LSMAPeriod + 1));

    LSMABuffer1[shift] = 0;
    LSMABuffer2[shift] = 0;

    if (wt>Close[shift]) LSMABuffer2[shift] = EMPTY_VALUE;
    if (wt<Close[shift]) LSMABuffer1[shift] = EMPTY_VALUE;
  }

//---- 
   
//----
   return(0);
  }
//+------------------------------------------------------------------+